#include "easy.h"
#include "packet.h"


/************************************************************************
 *	Ȥ.
 ************************************************************************
 */
void usage(void)
{
	printf( "Usage is:\n"
			"  dis78k [Options] dumplist.txt\n"
			"Options:\n"
			"  -u     print all capitalization.\n"
			"  -h     add hexadecimal suffix (ex. 0123H )\n"
			"  -d     debug info.\n"
	);
	exit(0);
}


void ToLowers(char *s);
FILE *ifp;

static Packet packet;

/*********************************************************************
 *	ʸ c ʸʤ飱֤.
 *********************************************************************
 */
static	char is_space(char c)
{
	if((c==' ') || (c=='\t')) return 1;
	return 0;
}
/*********************************************************************
 *	ʸ c ʸʤ飱֤.
 *********************************************************************
 */
static	char is_separator(char c)
{
	if(is_space(c)) return 1;
	if(c==',') return 1;
	return 0;
}
#if	0
/*********************************************************************
 *	ʸ *buf Ƭ;ɤФ.
 *********************************************************************
 */
static	char *space_skip(char *buf)
{
	while(*buf) {
		if(is_space(*buf)==0) return buf;
		buf++;
	}
	return buf;
}
#endif
/**********************************************************************
 *	ʸ(c)(0..15)Ѵ.
 **********************************************************************
 *	:
 *		char c    :	ʸASCII.
 *		char radix: 10 ⤷16.
 *	:
 *		0..15 ο͡⤷ (-1) Ѵʤ
 */
static	int	hex1int(char c,char radix)
{
	if((c>='0')&&(c<='9')) return c - '0';
	if(radix == 10) return -1;

	// ʿ򰷤.
	if((c>='a')&&(c<='f')) return c - 'a' + 10;
	if((c>='A')&&(c<='F')) return c - 'A' + 10;
	return -1;
}

/****************************************************************************
 *	ʸͤѴ.
 ****************************************************************************
 * :
 *	char *s : ʸݥ.
 *	int  *p : ̤֤ݥ.
 *	char radix : 10 ⤷ 16
 * :
 *  ɤ߿ʤ᤿ʸ , 0 ξѴǽ.
 */
Uchar str2int(char *s,int *p,char radix)
{
	int   n;
	Uchar idx=0;	//ɤ߿ʤ᤿ʸ.
	int	  val=0;	//Ѵ줿.

	n = hex1int(*s,radix);if(n<0) return 0;

	// ɤ߼.
	while(1) {
		n = hex1int(*s,radix);if(n<0) break;
		val = val * radix + n;
		s++;
		idx++;
	}
	*p = val;
	
	// ڤʸå.
	while(1) {
		if(is_separator(*s)==0) break;
		s++;
		idx++;
	}
	return idx;
}

/************************************************************************
 *	
 ************************************************************************
 */
void print_bin(void)
{
	int i;
	printf("%04x",packet.adrs);
	for(i=0;i<packet.size;i++) {
		printf(" %02x",packet.bindata[i]);
	}
	printf("\n");
}
/************************************************************************
 *	ʥץꥹȤ򣱹ʬɤ߹.
 ************************************************************************
 */
int Read_HexDump( Packet *p ,char *linebuf)
{
	char *buf;
	int idx;
	int start_adrs = 0;
	int hexdata1 = 0;

	buf = linebuf;

	//ǽΰ.	start_adrs Ȥߤʤ.
	idx = str2int(buf, &start_adrs ,16);
	if(idx == 0) return 0;	// ʤ.
	buf += idx;

	p->adrs = start_adrs;

	// ǡ򣱣Хʬɤ߼.
	while(1) {
		//ܰʹߤΰ 16ХȤΥǡ.
		idx = str2int(buf, &hexdata1 ,16);
		if(idx == 0) break;	// ʤ.
		buf += idx;
		p->bindata[p->size++] = hexdata1;
	}
#if	1		// 2009-12-25
	if ( p->size > 16 ) p->size = 16; return p->size;
#else
	return p->size;
#endif
}

/************************************************************************
 *	ƼץꥹȤ򣱹ʬɤ߹.
 ************************************************************************
 *	͡ɤ߹̣Хȿ.
 */
int Read_Dump( Packet *p )
{
	char linebuf[4096];
	int rc , c;
	static	int eof_flag=0;

	p->adrs = 0;
	p->size = 0;
	p->off  = 0;

	if( eof_flag==1 ) return EOF;

	// ɤ߹.
	rc = getln(linebuf,ifp);
	if( rc == EOF) {
		eof_flag=1;
		return EOF;
	}
	// Ƭʸǥ쥳ɼ̤Ƚ̤.	
	c = linebuf[0];
	switch(c) {
	 case ':':	rc = Read_IntelHex(p , linebuf);break;
	 case 'S':	rc = Read_Srecord( p , linebuf);break;
	 default:	rc = Read_HexDump( p , linebuf);break;
	}
	return rc;
}

/************************************************************************
 *	ɬפʤץꥹȤ򣱹ʬɤ߹.
 ************************************************************************
 *	req   ׵᤹Хȿ.
 *	͡ɤ߹̣Хȿ.
 *
 *		׵᤹Хȿɥ쥹Ϣ³ˤʤޤǥ
 *			ɤ߹߽³.
 *
 *			ɥ쥹Ϣ³ˤʤäϡʳǤ֤ͤ.
 */
int	Read_Binary( Packet *p , int req)
{
	static Packet pkt;
	static last_pkt= 0;	// 1=ľpktͭͤĤäƤ.
	int rc;
	int bufsize;
	int start_adrs = 0;

	while( (p->size - p->off) < req) {	//Ѳǽǡ­ʤɤ߹߽.
		if( last_pkt == 0) {
			rc = Read_Dump( &pkt );
			if(rc == EOF) return EOF;
			if(rc == 0) continue;
		}
		last_pkt = 0;
		start_adrs = pkt.adrs;

		// ɥ쥹Ϣ³ʤ
		if( start_adrs != (p->adrs + p->size) ) {
//			printf("start_adrs %x != (adrs %x + size %x)\n",start_adrs ,p->adrs , p->size);
			// ΥǡϻĤäƤʤɥ쥹ꥻå.
			bufsize = p->size - p->off;
			if(bufsize==0) {
				// ¤Τ򥳥ԡ
				*p = pkt;		//ɥ쥹ǡ.
				printf("\n");
			}else{
				//packet򤽤ΤޤֵѤ.
				last_pkt = 1;	//ľpkt¸.
				return p->size;
			}

		}else{
//			printf("adrs1 == (addr + len)\n");
			// Ϣ³ϡХåեλĤư.
			memcpy(p->bindata,p->bindata + p->off , 16);
			// եåȰư.
			p->size -= p->off;
			p->adrs += p->off;
			// ɤ߹ʬɵ.
			memcpy(p->bindata + p->size , pkt.bindata , pkt.size);
			p->size += pkt.size;
			p->off   = 0;
		}
	}
//	print_bin();
	return p->size;
}
/************************************************************************
 *	ץꥹȤȯŪɤߤʤմ.
 ************************************************************************
 */
int	disasm(void)
{
	char hexbuf[32];
	char disbuf[256];
	Uchar *bin;

	int adrs;
	int bufsize;
	int reqsize;
	int opsize;
	int rc;
	int debugf=0;

	packet.adrs = (-1);
	packet.size = 0;
	packet.off  = 0;

	if(IsOpt('d')) { debugf |= MODE_DEBUG_INFO;}
	if(IsOpt('h')) { debugf |= MODE_HEX_SUFFIX;}

	while(1) {
		reqsize = 4;
redo:
		// ɬפʤ顢ץꥹȤ򣱹(16byte)ɤ߹.
		rc = Read_Binary( &packet , reqsize);
//		if(rc == EOF ) return EOF;

		adrs = packet.adrs    + packet.off;
		bin  = packet.bindata + packet.off;
		bufsize = packet.size - packet.off;

//		printf("dis: off=%x size=%x\n",packet.off,packet.size);
		// ե֥뤹.
		opsize = Disasm_Line(disbuf,bin,adrs,debugf);
		 		 Disasm_Hex( hexbuf,bin,adrs,opsize);

		// -u ץꤷʤ硢ʸɽ.
		if(!IsOpt('u')) {
			ToLowers(disbuf);
			ToLowers(hexbuf);
		}

		if(opsize <= bufsize) {
			// .
			printf("%-16s %s\n", hexbuf,disbuf);	// 4+3*4=16
			// ݥ󥿤ʤ.
			packet.off += opsize;
		}else{
			if(rc == EOF ) return EOF;
			reqsize = 4;
			goto redo;
		}
	}
	return 0;
}
/************************************************************************
 *	ץꥹȤ򥪡ץ󡢵մ.
 ************************************************************************
 */
void disasm_main(char *file)
{
	Ropen(file);
	disasm();
	Rclose();
}

/************************************************************************
 *	øᥤ.
 ************************************************************************
 */
int main(int argc,char **argv)
{
	Getopt(argc,argv);

	Inst_init();
	if(argc<2) {
		usage();
	}
	disasm_main(argv[1]);

	return 0;
}
/************************************************************************
 *
 ************************************************************************
 */

